--Variables
local nextSecond = 1;
local timeCount = 0;

-- Functions
local onUpdate, onSecond;

local eventHolder = CreateFrame("Frame");
eventHolder:RegisterEvent("OnUpdate");
eventHolder:SetScript("OnUpdate", function(self, elapsed) onUpdate(elapsed) end);

function onUpdate(elapsed)
    timeCount = timeCount + elapsed;
    if timeCount > nextSecond then
        nextSecond = nextSecond + 1;
        onSecond();
    end

    simpleDpsPlayerStatsTable.updateCombatTime(elapsed);
end

function onSecond()
    simpleDpsPlayerStatsTable.calculateDps();
    simpleDpsPlayerStatsTable.updateGroupMembers();
    SimpleDpsGui.updateGui(tableSize(simpleDpsPlayerStatsTable.getPlayerStats()), simpleDpsPlayerStatsTable.getPlayerStats());
end

-- Combat log handler
eventHolder:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
eventHolder:SetScript("OnEvent", function(self, event, ...)
    local timestamp, ev, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20 = ...;

    local sum;

    if ev == "SWING_MISSED" then
        if arg12 == "ABSORB" then
            sum = arg14;
            simpleDpsPlayerStatsTable.damageDone(sourceName, sum);
        elseif arg15 == "ABSORB" then
            sum = arg17;
            simpleDpsPlayerStatsTable.damageDone(sourceName, sum);
        else
            return;
        end
    end

    if string.match(ev, "DAMAGE") then
        if ev == "SWING_DAMAGE" then
            sum = arg12 + (arg17 or 0);
            simpleDpsPlayerStatsTable.damageDone(sourceName, sum);
        else
            sum = arg15 + (arg20 or 0);
            simpleDpsPlayerStatsTable.damageDone(sourceName, sum);
        end
    end


end)