local playerStats = {
    -- Current exaplanation of the data in the tables:
    -- 1: The total damage dealt.
    -- 2: The total time spent in combat.
    -- 3: The current dps.
    -- More data may be added to the table if I choose to develop this addon further.

    -- The player using the addon should be added automatically.
    [UnitName("player")] = {0, 0, 0};
}

--Local functions
--Very weird piece of code. This seems to be the most easy way to get a pet's owners name.
local scanTool = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" )
scanTool:SetOwner( WorldFrame, "ANCHOR_NONE" )
local scanText = _G["ScanTooltipTextLeft2"]

function getPetOwner(petName)
    scanTool:ClearLines()
    scanTool:SetUnit(petName)
    local ownerText = scanText:GetText()
    if not ownerText then return nil end
    local owner, _ = string.split("'",ownerText)

    return owner
end

-- global functions
simpleDpsPlayerStatsTable = {};

simpleDpsPlayerStatsTable.updateGroupMembers = function()
    local groupMembers={}
    if IsInRaid() then
        for i=1,40 do
            if (UnitName('raid'..i)) then
                tinsert(groupMembers,(UnitName('raid'..i)))
            end
        end
    elseif IsInGroup() then
        for i=1,4 do
            if (UnitName('party'..i)) then
                tinsert(groupMembers,(UnitName('party'..i)))
            end
        end
    end

    for index, playerName in ipairs(groupMembers) do
        if playerStats[playerName] == nil then
            playerStats[playerName] = {0, 0, 0};
        end
    end

    for player, stats in pairs(playerStats) do
        if not arrayContainsValue(groupMembers, player) and player ~= UnitName("player") then
            playerStats[player] = nil;
        end
    end
end

simpleDpsPlayerStatsTable.calculateDps = function()
    for player, stats in pairs(playerStats) do
        if stats[2] ~= 0 then
            playerStats[player][3] = floor(stats[1]/stats[2] + 0.5);
        end
    end
end

simpleDpsPlayerStatsTable.getPlayerStats = function()
    return playerStats;
end

simpleDpsPlayerStatsTable.damageDone = function(playerName, ammount)
    indexOfSplit = string.find(playerName, "-");
    if indexOfSplit then
        playerName = string.sub(playerName, 1, indexOfSplit - 1);
    end

    --if a owner is found for the pet, then that player should get the damage count.
    local petOwner = getPetOwner(playerName);
    if playerStats[petOwner] ~= nil then
        playerName = petOwner;
    end

    if playerStats[playerName] then
        playerStats[playerName][1] = playerStats[playerName][1] + ammount;
    end
end

simpleDpsPlayerStatsTable.updateCombatTime = function(elapsed)
    for player, stats in pairs(playerStats) do
        if UnitAffectingCombat(player) then
            playerStats[player][2] = playerStats[player][2] + elapsed;
        end
    end
end

simpleDpsPlayerStatsTable.reset = function()
    playerStats = {
        [UnitName("player")] = {0, 0, 0};
    }
    simpleDpsPlayerStatsTable.updateGroupMembers();
end